module Patches
  module AttachmentPatch

    def self.included(base)
      base.extend(ClassMethods)
      base.send(:include, InstanceMethods)
      base.class_eval do
        unloadable
        alias_method :validate_file_extension, :validate_file_extension_ext
      end
    end

    module ClassMethods
    end

    module InstanceMethods

      def validate_file_extension_ext
        if @temp_file
          extension = File.extname(filename)
          unless self.class.valid_extension?(extension)
            errors.add(:base, l(:error_attachment_extension_not_allowed, :extension => extension))
          end

          reg = Setting.send(:attachment_name_regexp)
          if Regexp.new(reg).match(filename) == nil
            errors.add(:base, l(:error_attachment_name_not_valid, :regexp => reg.size.to_s, :filename => filename.size.to_s))
          end
        end
      end

    end

  end
end
